<template>
    <div id="title">
        <h1 class="font-weight-normal">{{ title.name }}</h1>
        <p class="my-0">{{ title.released }} {{ title.type }}</p>
        <p v-if="genresNotEmpty" class="my-0">{{ genresToString }}</p>
        <p v-if="title.budget" class="my-0">Cost {{ budgetSeparated }} USD</p>
        <p v-if="title.gross" class="my-0">Made {{ grossSeparated }} USD</p>
        <div v-if="cast.length > 0">
            <hr class="my-3">
            <h4 class="font-weight-normal">Cast</h4>
            <cast-table view="title" :roles="cast"/>
        </div>
        <div v-if="crew.length > 0">
            <hr class="my-3">
            <h4 class="font-weight-normal">Crew</h4>
            <crew-table view="title" :crew="crew"/>
        </div>
        <!--<p>
            <router-link :to="'/entertainment/' + title.id + '/edit'">
                <button class="btn btn-primary">
                    <span class="fas fa-edit"/> Edit
                </button>
            </router-link>
            <router-link :to="'/entertainment/' + title.id + '/delete'">
                <button class="btn btn-primary">
                    <span class="fas fa-trash"/> Delete
                </button>
            </router-link>
        </p>-->
    </div>
</template>

<script>
    import CastTable from "@/components/CastTable";
    import CrewTable from "@/components/CrewTable";

    export default {
        name: "Title",
        components: {
            CastTable,
            CrewTable
        },
        data() {
            return {
                title: {},
                type: {},
                genres: [],
                cast: [],
                crew: [],
            }
        },
        mounted() {
            this.getTitle();
            this.getCast();
            this.getCrew();
        },
        computed: {
            genresToString() {
                const genres = [];

                for (let genre of this.genres) {
                    genres.push(genre.name)
                }

                return genres.join(', ');
            },
            genresNotEmpty() {
                return this.genres.length > 0;
            },
            budgetSeparated() {
                return this.numberSeparator(this.title.budget)
            },
            grossSeparated() {
                return this.numberSeparator(this.title.gross)
            },
        },
        methods: {
            async getTitle() {
                try {
                    let id = this.$route.params.id;
                    let response = await fetch('http://localhost:8081/api/entertainment/' + id);
                    let data = await response.json();
                    this.title = data[0];
                    id = this.title.type_id;
                    response = await fetch('http://localhost:8081/api/types/' + id);
                    data = await response.json();
                    this.type = data[0];
                    id = this.title.id;
                    response = await fetch('http://localhost:8081/api/genres?title_id=' + id);
                    data = await response.json();
                    this.genres = data;
                } catch (e) {
                    console.error(e);
                }
            },
            async getCast() {
                try {
                    const id = this.$route.params.id;
                    const response = await fetch(
                        `http://localhost:8081/api/works?acting=true&title_id=${id}`
                    );
                    this.cast = await response.json();
                } catch (e) {
                    console.error(e);
                }
            },
            async getCrew() {
                try {
                    const id = this.$route.params.id;
                    const response = await fetch(
                        `http://localhost:8081/api/works?acting=false&order=j.name&title_id=${id}`
                    );
                    this.crew = await response.json();
                } catch (e) {
                    console.error(e);
                }
            },
            numberSeparator(number) {
                number = number + '';
                for (let i = 9; i > 0; i -= 3) {
                    if (number.length > i) {
                        number = `${number.substr(0, number.length - i)},${number.substr(number.length - i, number.length - 1)}`;
                    }
                }
                return number
            }
            /*async deleteTitle() {
                try {
                    const id = this.title.id;
                    return id;
                } catch (e) {
                    console.error(e);
                }
            }*/
        }
    }
</script>

<style scoped>
</style>